#include "template.cpp"


bool sndCmp(ii a, ii b){return a.second<b.second;}
bool pntCmp(vi::iterator a, vi::iterator b){return *a<*b;}

vi countingSort(int k, vi vin, vi stb=vi()){    //O(n+k)
    int n=vin.size();
    vi vout(n), cnt(k);
    fr(i,0,n) cnt[vin[i]]++;
    fr(i,1,k) cnt[i]+=cnt[i-1];
    for(int i=n-1;i>=0;i--){
        vout[cnt[vin[i]]-1]=stb.size()?stb[i]:vin[i];
        cnt[vin[i]]--;
    }
    return vout;
}

vi radixSort(int k, vi v, int b=10){    //O(n*log(k))
    int n=v.size();
    vi dgt(n);
    for(int d=1;d<k;d*=b){
        fr(i,0,n) dgt[i]=(v[i]/d)%b;
        v=countingSort(b,dgt,v);
    }
    return v;
}/*

vi LIS(vi v){
    int l;
    vi prnt, last, lis;
    fr(i,0,v.size()){
        int j = lower_bound(last.begin(),last.end(),v.begin()+i,pntCmp)-last.begin();
        prnt[i]=j?last[j-1]:-1;

    }
    return lis;

     L = 0
 for i = 1, 2, ... n:
    binary search for the largest positive j ≤ L
      such that X[M[j]] < X[i] (or set j = 0 if no such value exists)
    P[i] = M[j]
    if j == L or X[i] < X[M[j+1]]:
       M[j+1] = i
       L = max(L, j+1)
}*/

vi itvSchd(vii itv){    //O(n)
    sort(itv.begin(),itv.end(),sndCmp);
    vi schd(1,0);
    int k=0;
    fr(i,1,itv.size()){
        if(itv[i].first>itv[k].second){
            schd.push_back(i);
            k=i;
        }
    }
    return schd;
}

pair<int,int> cycleFinding(int (*f)(int), int x0){    //O(mu+lambda)
    int mu=0, lambda=1, tortoise = f(x0), hare = f(f(x0));
    while(tortoise!=hare){
        tortoise = f(tortoise);
        hare = f(f(hare));
    }
    hare = tortoise; tortoise = x0;
    while(tortoise!=hare){
        tortoise = f(tortoise);
        hare = f(hare);
        mu++;
    }
    hare = f(tortoise);
    while(tortoise!=hare){
        hare = f(hare);
        lambda++;
    }
    return make_pair(mu,lambda);
}

//linear algebra(gaussian elimination)
//matrixmult
//matrix chain

int main(){
    int n, k;
    cin>>n>>k;
    vi v(n);
    fr(i,0,n) cin>>v[i];
    string text,word;
    int p=0,m=0;
    while(p!=string::npos){
        p=text.find(word,p);
        m++;
    }
    vector<int>::iterator it;
    it=lower_bound(v.begin(), v.end(), 20);
    vi c=countingSort(k,v); fr(i,0,n) cout<<c[i]<<ends; cout<<endl;
    vi r=radixSort(k,v); fr(i,0,n) cout<<r[i]<<ends; cout<<endl;
    //itvShed(itv);
}
